
/* 
 * Default_Sort_Column
 *      This variable declares which column the list of queues should be
 *      sorted by when first loaded.
 *
 *      Valid values are:
 *          "Name"      - Sort on the name column
 *          "Type"      - Sort on the type column
 *          "Depth"     - Sort on the depth column
 *          ""          - Default order (no sort applied)
 *
 */

var Default_Sort_Column = "Depth";

/*
 * Default_Sort_Direction
 *      If a column is specified in Default_Sort_Column, this variable
 *      controls the direction of sorting.
 *
 *      Valid values are:
 *          "Ascending" - Sort in ascending order
 *          "Descending" - Sort in descending order
 *
 *      If Default_Sort_Column is not defined or set to default, this variable
 *      is ignored
 */

var Default_Sort_Direction = "Descending";
/*
 * Default_MQ_Type_Filter
 *      This value controls the default value for the MQ Type filter
 *
 *      Valid values are:
 *          "all"   - Display all queues
 *          "local" - Only display queues with the type 'QLOCAL'
 *          "remote"- Only display queues with the type 'QREMOTE'
 *          "alias" - Only display queues with the type 'QALIAS'
 *          "model" - Only display queues with the type 'QMODEL'
 */

var Default_MQ_Type_Filter = "local";

/*
 * Default_Hide_Empty_Queues
 *      Set this variable to 1 to hide empty queues by default
 *      Set this variable to 0 to show empty queues by default
 */

var Default_Hide_Empty_Queues = 1;
//var Default_Hide_Empty_Queues = 0;

/*
 * Default_Hide_System_Queues
 *      Set this variable to 1 to hide queues matching the SYSTEM.* filter
 *      Set this variable to 0 to show all queues
 */

var Default_Hide_System_Queues = 1;
//var Default_Hide_Empty_Queues = 0;

/*
 * Default_Hide_Queue_Menus
 *      Set this variable to 1 to hide the menu icon next to the queue name
 *      Set this variable to 0 to show the menu icon
 *
 *      Hiding the menu icon greatly improves the speed of rendering a large
 *      list of queues.
 */

var Default_Hide_Queue_Menus = 1;
//var Default_Hide_Queue_Menus = 0;
function getDefaultSortCol()
{
    return Default_Sort_Column;
}

/*
 * Default_Use_Local_Queues_Cache
 *      Set this variable to 1 to enable local cache
 *      Set this variable to 0 to disable local cache
 */
var Default_Use_Local_Queues_Cache = 1;
