/*
######################################################################

             IBM Confidential
             
             OCO Source Materials
             
             (C) Copyright IBM Corp. 2007
             
             The source code for this program is not
             published or otherwise divested of its
             trade secrets, irrespective of what has
             been deposited with the U.S Government
             Copyright Office.

######################################################################
#$Id: kxyList.js,v 1.1.2.4 2009/08/20 09:19:30 cjj Exp $#
######################################################################
# Copyright 1999-2003, Candle Corporation, a California corporation.  
# All rights reserved. International copyright secured.
#
# This material is proprietary to Candle Corporation and is not to be
# reproduced, used, or disclosed except in accordance with program
# licenses or upon written authorization of Candle Corporation.
#
#######################################################################*/
/**********************************************************************************************
					List.js
***********************************************************************************************
List.js has functions that help in displaying the list of all the Queues for a Queue Manager 
***********************************************************************************************
***********************************************************************************************/

var windowClose = 0;
var correction = 0;
var xml_queue;
var qmgr_name;

var currentlist;
var currenttype;

var currentTypeFilter;

var sortCol = Default_Sort_Column;

var sortOrder = Default_Sort_Direction;

function updateList(xmlResult,type,flag)
{
    var stime = new Date();
    currentlist = [];
    currenttype = type;
    //var mindepthctrl = window.parent.frame2.frame3.document.getElementById('mindepth');
    //var dpth = mindepthctrl.value;
    var dpth = -1;

    if (dpth == null || dpth == '' || dpth == 'all')
    {
        dpth = -1;
    }

    if(QType != TYPEMQ)
        xml_queue = xmlResult;

    var path = "//QueueList/Queue";
    if(flag != null && flag == 1)
        path = "//Queue";

    var qname;
    var q_type;
    var q_depth;
    var tempQname;

    var retcode = 0;
    if (xmlMQAttrib != null && getTag(RETURNCODE, xmlMQAttrib) == "Success")
    {
        retcode = 1;
    }
    
    //cl begin
    if(type == TYPEMQ)
    {
    	var current = getNodes("//Response/Body/Queue",xmlMQAttrib);

        var t = 0;
        var row = 0;
        for (t = 0; t < current.length; t ++)
        {
            var n = current[t].selectSingleNode("QUEUE");

            if (n == null)
            {
                qname = "unknown";
            }
            else
            {
                qname = n.text;
            }

            qname = ltrim(rtrim(qname));

            if(retcode == 1)
            {

                var n = current[t].selectSingleNode("CURDEPTH");
                if (n != null)
                {
                    q_depth = n.text;
                }
                else
                {
                    q_depth = "";
                }

                n = current[t].selectSingleNode("TYPE");
                if (n != null)
                {
                    q_type = rtrim(ltrim(n.text));
                }
                else
                {
                    q_type = "";
                }
            }

            /* Check if it matches the depth filter */
            if (dpth != -1)
            {
                if (q_depth == null)
                    continue;
                if (q_depth < dpth)
                    continue;
            }

            currentlist[row] = [ qname, q_type, q_depth ];
            row ++;
        }
    }
    else if(type == TYPEJMS)
    {	
		var counter = count(path,xmlResult);
		var t = 0;
		var row = 0;
		for(t=0;t<counter;t++)
		{
			qname = getTag(path + "["+t+"]",xmlResult);
			if(qname==null)
			{
				qname = "unknown";
			}

			qname = ltrim(rtrim(qname));
			
			currentlist[row] = [ qname, "" , "" ];
			row ++;
		}	
    }
    //cl end

    var etime = new Date();
    debugTime("updateList",(etime.getTime() - stime.getTime()));
}

function sortname(a,b)
{
    if (a[0] < b[0])
    {
        return -1;
    }
    else if (a[0] > b[0])
    {
        return 1;
    }
    return 0;
}

function sorttype(a,b)
{
    if (a[1] < b[1])
    {
        return -1;
    }
    else if (a[1] > b[1])
    {
        return 1;
    }
    else
    {
        // regardless of order we want ascending name on the second sort
        if (sortOrder == "Descending")
        {
            return sortname(b,a);
        }
        else
        {
            return sortname(a,b);
        }
    }
}

function sortdepth(a,b)
{
    if (a[2] == b[2])
    {
        // regardless of order we want ascending name on the second sort
        if (sortOrder == "Descending")
        {
            return sortname(b,a);
        }
        else
        {
            return sortname(a,b);
        }
    }
    return (a[2] - b[2]);
}

function applySort()
{
    var stime = new Date();
    if (sortCol == "" || sortCol == "Name")
    {
        currentlist.sort(sortname);
    }
    else if (sortCol == "Type")
    {
        currentlist.sort(sorttype);
    }
    else
    {
        currentlist.sort(sortdepth);
    }

    if (sortOrder == "Descending")
    {
        currentlist.reverse();
    }
    var etime = new Date();
    debugTime("sortList",(etime.getTime() - stime.getTime()));
}

/* Update the list header to reflect sort orders */
function updateListHeaderRow()
{
    var dir;

    if (sortOrder == "Ascending")
    {
        dir = "ASC";
    }
    else if (sortOrder == "Descending")
    {
        dir = "DESC";
    }

    var pdoc = window.parent.frame2.frame3.document;
    var hdr = pdoc.getElementById('namecol');

    if (sortCol == "Name")
    {
        hdr.innerText = "Name (" + dir + ")";
    }
    else
    {
        hdr.innerText = " Name ";
    }

    hdr = pdoc.getElementById('typecol');

    if (sortCol == "Type")
    {
        hdr.innerText = "Type (" + dir + ")";
    }
    else
    {
        hdr.innerText = " Type ";
    }

    hdr = pdoc.getElementById('depthcol');

    if (sortCol == "Depth")
    {
        hdr.innerText = "Depth (" + dir + ")";
    }
    else
    {
        hdr.innerText = " Depth ";
    }
}

function toggleSort(column)
{
    if (column == sortCol)
    {
        // Toggle sort
        if (sortOrder == "Ascending")
        {
            sortOrder = "Descending";
        }
        else
        {
            sortOrder = "Ascending";
        }
    }
    else
    {
        sortCol = column;
        sortOrder = Default_Sort_Direction;
    }

    applySort();
    // Regen HTML
    updateListHeaderRow();

    rebuildHTMLList();
}

function rebuildHTMLList()
{
    var pdoc = window.parent.frame2.frame3.document;

    var targetdiv = pdoc.getElementById('listDiv');

    var newdiv = buildHTMLList();
    var par = targetdiv.parentNode;
    //par.removeChild(targetdiv);
    //par.appendChild(newdiv);
    targetdiv.outerHTML = newdiv.outerHTML;
    //targetdiv.parentNode.replaceChild(newdiv,targetdiv);

}

function setUserHiddendValues(){
	   var tmpQueueReadOnlyUser = getTag("//Body//QueueReadOnlyUser",userProfile);
	    if (tmpQueueReadOnlyUser != null && tmpQueueReadOnlyUser == "true")
	    {
	    	window.parent.frame2.frame3.queueReadOnlyUser.value = "true" ;
	    }
	    
	    var tmpClearQueueOnlyUser = getTag("//Body//ClearQueueOnlyUser",userProfile);
	    if (tmpClearQueueOnlyUser != null && tmpClearQueueOnlyUser == "true")
	    {
	    	window.parent.frame2.frame3.clearQueueOnlyUser.value = "true" ;	    	
	    }
	
}

function buildHTMLList()
{
	setUserHiddendValues();
	var stime = new Date();
    var pdoc = window.parent.frame2.frame3.document;

    if(document.body.clientHeight < 700)
    {
        if(browser == "NS")
            correction = 145;
        else
            correction = 135;
    }
    else
        correction = 170;
    if(browser != "NS")
        var heightScreen = document.body.clientHeight - correction;
    else
        var heightScreen = window.innerHeight - correction;
    // the List
    var div = pdoc.createElement("div");
    div.id = "listDiv";
    div.setAttribute("STYLE", "height:" + heightScreen +";overflow:auto;width:100%;table-layout:fixed");
    div.setAttribute("class", "scroll");

    div.innerHTML = "<table id='queuetable'><tbody id='queuebody'></tbody></table>";

    var newbody = pdoc.createElement("tbody");
    newbody.id = "queuebody";
    var frag = pdoc.createDocumentFragment();

    table = div.firstChild;

    table.border = 0;
    table.setAttribute("style", "table-layout:fixed");
    table.cellPadding = 5;
    table.cellSpacing = 0;
    table.width = "100%";

    var qname;
    var tempQname;
    var q_depth;
    var q_type;
    //var menuicon;

    var hideempty = window.parent.frame2.frame3.hideEmpty;
    var hidesystem = window.parent.frame2.frame3.hideSystem;

    var typefilt = window.parent.frame2.frame3.getFilterType();
    currentTypeFilter = 0;
    var doTypeCheck = 1;
    var checkType = "";
    var namefilter = window.parent.frame2.frame3.getNameFilter();
    var doNameFilter = 1;
    // Filter the QueueNames in client if the "enableQueueNameFilter" is true, otherwise we do it in server.
    enableQueueNameFilter = false;
    if (namefilter == "")
    {
    	//cjj, enable the <EnableQueueNameFilter> tag in the config.xml file. 
    	if (enableQueueNameFilter) 
		{
        	doNameFilter = 1;
			namefilter = queueNameMask;
			var last=namefilter.charAt(namefilter.length-1);
			if(last=="*")
			{
				namefilter="^"+namefilter.substring(0,namefilter.length-1);
			}	
		}
		else 
		{
			doNameFilter = 0;
		}
    	//cjj end
    }
	else
	{
		var last=namefilter.charAt(namefilter.length-1);
		if(last=="*")
		{
			namefilter="^"+namefilter.substring(0,namefilter.length-1);
		}
	}

    if (typefilt == "all")
    {
        doTypeCheck = 0;
    }
    else if (typefilt == "local")
    {
        checkType = "QLOCAL";
        currentTypeFilter = 1;
    }
    else if (typefilt == "remote")
    {
        checkType = "QREMOTE";
        currentTypeFilter = 2;
    }
    else if (typefilt == "alias")
    {
        checkType = "QALIAS";
        currentTypeFilter = 3;
    }
    else if (typefilt == "model")
    {
        checkType = "QMODEL";
        currentTypeFilter = 4;
    }

    var row = 0;
    for (var t = 0; t < currentlist.length; t ++)
    {
        qname = currentlist[t][0];
        if (currenttype == TYPEMQ)
        {
            q_type = currentlist[t][1];
            q_depth = currentlist[t][2];

            if (hideempty == 1 && q_depth == 0)
            {
                continue;
            }
            // Apply filters
            if (doTypeCheck)
            {
                if (q_type != checkType)
                {
                    continue;
                }
            }

            if (hidesystem == 1)
            {
                if (qname.match("^SYSTEM[.].*") != null)
                {
                    continue;
                }                
            }
			
            if (doNameFilter == 1)
            {
            	//cjj, enable the <EnableQueueNameFilter> tag in the config.xml file.
				if (enableQueueNameFilter) 
				{
					var queueNameArray = new Array();
					queueNameArray = queueNameList.split(",");
					var flag;
					// for "And" operation
					if (queueNameRelation.toLowerCase() == "and") 
					{
						for (var i=0; i<queueNameArray.length; i++)
						{
							flag = true;
							if(qname.match(queueNameArray[i]) != null && qname.match(namefilter) != null)
							{
								flag = false;
								break;
							}
						}
	                	if (flag == true)
		                {
		                    continue;
		                }
					}
					// for "Or" operation
					else if (queueNameRelation.toLowerCase() == "or") 
					{
						for (var i=0; i<queueNameArray.length; i++)
						{
							flag = true;
							if(qname.match(queueNameArray[i]) != null || qname.match(namefilter) != null)
							{
								flag = false;
								break;
							}
						}
	                	if (flag == true)
		                {
							continue;
		                }
			
					}
				}
				//cjj end
				else 
				{
	                if (qname.match(namefilter) == null)
	                {
	                    continue;
	                }			
				}
            }
			makeRow(frag, row, qname, q_type, q_depth, currenttype, pdoc);
        }
        else
        {
            makeRow(frag, row, qname, null, null, currenttype, pdoc);
        }
        row ++;
    }

    newbody.appendChild(frag);
    table.replaceChild(newbody,table.firstChild);
    if (t == 0)
    {
        M_alert("There are no queues matching the filter criteria for the queue manager");
    }

    div.appendChild(table);
    var etime = new Date();
    debugTime("generateHTML",(etime.getTime() - stime.getTime()));
    return div;
}

/* listHeaderRow - creates the table header for the list of queues on the queue manager */
function listHeaderRow(table, qmgr, type)
{
    var row = table.insertRow();
    var queueReadOnlyUser = false ;
    var clearQueueOnlyUser = false ;
    var tmpQueueReadOnlyUser = getTag("//Body//QueueReadOnlyUser",userProfile);
    if (tmpQueueReadOnlyUser != null && tmpQueueReadOnlyUser == "true")
    {
    	queueReadOnlyUser = true;
    }
    
    var tmpClearQueueOnlyUser = getTag("//Body//ClearQueueOnlyUser",userProfile);
    if (tmpClearQueueOnlyUser != null && tmpClearQueueOnlyUser == "true")
    {
    	clearQueueOnlyUser = true;
    }

    row.setAttribute("class","bg1");
    var cell = row.insertCell();
    cell.innerHTML="<font><b>List of Queues for " + qmgr + "</b></font>";
    cell = row.insertCell();
    cell.colSpan = 2;
    cell.align = "right";
    if(clearQueueOnlyUser || queueReadOnlyUser){
    	cell.innerHTML= "<b><font>&nbsp;</font> </b>";	
    }else{
      cell.innerHTML= "<b><a href='#' onClick=parent.parent.M_openCreateQueueDialog('"+type +"')><font> Create Queue </font></a></b>";
    }
    row = table.insertRow();
    row.setAttribute("class","bg2");
    if (type == TYPEMQ)
    {
        cell = row.insertCell();
        cell.width = "77%";
        cell.innerHTML = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<font class='dark'><b><a id='namecol' href='#' class ='list' onClick=parent.parent.toggleSort('Name')> Name </b></font>";



        cell = row.insertCell();
        cell.align = "left";
        cell.width = "12%";
        cell.innerHTML = "<font class='dark'><b><a id='typecol' href='#' class ='list' onClick=parent.parent.toggleSort('Type')> Type</b></font>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
        cell = row.insertCell();
        cell.align = "left";
        cell.innerHTML =  "<font class='dark'><b><a id='depthcol' href='#' class ='list' onClick=parent.parent.toggleSort('Depth')> Depth</b></font>&nbsp;";
    }
    else
    {
        cell = row.insertCell();
        cell.colSpan = 3;
        cell.innerHTML = "&nbsp;&nbsp;&nbsp;<font class='dark'><b> Name </b></font>";
    }

    return row;
}

/* append a row to the list of queues */
function makeRow(destination, rowno, qname, qtype, qdepth, type, pdoc )
{
    var newrow;
    var tmphtml;
    var fnt;
    // TODO: can this just be document. ?
    newrow = pdoc.createElement("tr");
    if ( (rowno) % 2 != 0)
    {
        newrow.setAttribute("class","bg2");
        newrow.width = "92%";
    }

    if (type == TYPEMQ)
    {
        // Column 1: popup menu
        var cell = pdoc.createElement("td");
        cell.width="5%";
        if (window.parent.frame2.frame3.hideMenuIcons == 0)
        {
            var menuicon = pdoc.createElement("img");
            menuicon.id = "Delete" + rowno;
            menuicon.width = 17;
            menuicon.height = 17;
            menuicon.src = "images/msg_menu.gif";
            //TODO IF08
            
            menuicon.onMouseOut = "hidePopupMenu('listT');";

            if(qtype != null)
                tmphtml = ",'"+qtype+"'";
            else
                tmphtml = "";

            menuicon.onmousedown = "parent.parent.frame1.hidePopupMenu('');parent.hidePopupMenu('');onMouseDownList(event,'" + qname +"','qmgr_name','Delete"+ rowno +"'" + tmphtml + ");";

            cell.appendChild(menuicon);
        }
        newrow.appendChild(cell);

        // Column 2: queue name
        cell = pdoc.createElement("td");
        cell.width = "74%";
        cell.align = "left";

        fnt = pdoc.createElement("font");
        fnt.setAttribute("class", "ListHeader");
        var block = pdoc.createElement("b");
        var ref = pdoc.createElement("a");
        ref.setAttribute("class", "list");
        ref.setAttribute("href", "#");

        if (qtype != null)
        {
            ref.onClick= "parent.parent.showOpenQDialog('qmgr_name','"+qname+"','"+qtype+"')";
        }
        else
        {
            ref.onClick= "parent.parent.showOpenQDialog('qmgr_name','"+qname+"')";
        }
        ref.innerText = qname;
        block.appendChild(ref);
        fnt.appendChild(block);
        cell.appendChild(fnt);
        newrow.appendChild(cell);

        // column 3: queue type
        cell = pdoc.createElement("td");
        cell.width = "14%";
        fnt = pdoc.createElement("font");
        fnt.setAttribute("class", "MessageAttrib");
        block = pdoc.createElement("b");

        if (qtype != null)
        {
            cell.align = "left";
            block.innerText = qtype;
        }
        else
        {
            block.innerText = "";
        }
        fnt.appendChild(block);
        cell.appendChild(fnt);
        newrow.appendChild(cell);

        // column 4: queue depth
        cell = pdoc.createElement("td");
        var qdiv = pdoc.createElement("div");
        qdiv.id = "td_" + qname;

        if (qdepth != null)
        {
            fnt = pdoc.createElement("font");
            fnt.setAttribute("class", "MessageAttrib");
            fnt.style.fontWeight = "bold";
            fnt.appendChild(pdoc.createTextNode(qdepth));
            qdiv.appendChild(fnt);
        }
        cell.appendChild(qdiv);
        newrow.appendChild(cell);
    }
    else
    {
            var tempQname = checkSpecialChars(qname);
            var cell = pdoc.createElement("td");
            cell.width = "5%";
            tmphtml = "<img id ='Delete"+rowno+"' width='17' height='17' src ='images/msg_menu.gif' onMouseOut=hidePopupMenu('listT2') onmousedown=parent.parent.frame1.hidePopupMenu('');parent.hidePopupMenu('');onMouseDownListJMS(event,"+rowno+",'qmgr_name','Delete"+rowno+"')/>";
            cell.innerHTML = tmphtml;
            newrow.appendChild(cell);

            cell = pdoc.createElement("td");

            cell.width = "74%";
            cell.aligh = "left";
            tmphtml = "<font class=ListHeader><b>";
            tmphtml += "<a href='#' class ='list' onClick=parent.parent.showOpenQDialog('qmgr_name',"+rowno+") >";
            tmphtml += tempQname + "</a></b></font>";
            cell.innerHTML = tmphtml;
            newrow.appendChild(cell);
    }

    destination.appendChild(newrow);
}

function generateList(target,xmlResult,qmgr,type, flag)
{
    var stime = new Date();
    var pdoc = window.parent.frame2.frame3.document;

    updateList(xmlResult,type,flag);
    applySort();

    qmgr_name = qmgr;

    var targetform = pdoc.createElement("form");
    targetform.setAttribute("id","QueueForm");

    
    var table = pdoc.createElement("table");
    table.border = 0;
    table.cellPadding = 2;
    table.cellSpacing = 0;
    table.width = "100%";

    targetform.appendChild(table);

    // List header
    row = listHeaderRow(table, qmgr, type);

    var newdiv = buildHTMLList();

    targetform.appendChild(newdiv);

    var x = pdoc.getElementById('Queue');
    x.innerHTML = targetform.outerHTML;

    updateListHeaderRow();

    etime = new Date();
    debugTime("generateList",(etime.getTime() - stime.getTime()));
}

/**********************************************************************************************
The function generateList is called by Manager in order to display the list of all the Queues 
for a Queue Manager. It takes following argument:
xmlResult	: is the XML DOM object for the XML that carries the names of all the queues for
		a Queue Manager.
qmgr		: carries the name of the Queue Manager for which list of Queues is displayed.	
type 		: carries either 'JMS' or 'MQSeries' in order to take any actions like 'Create 
		Queue' accordingly.
***********************************************************************************************/
function generateList2(xmlResult,qmgr,type, flag)
{
qmgr_name = qmgr;
//M_alert("There are no queues matching the filter criteria for the queue manager " +qmgr+ ".");
if(QType != TYPEMQ)
	xml_queue = xmlResult;
var list = "";
var rows = 0;
if(document.body.clientHeight < 700)
{
	if(browser == "NS")
		correction = 145;
	else
		correction = 135;
}
else
	correction = 170;
if(browser != "NS")
	var heightScreen = document.body.clientHeight - correction;
else
	var heightScreen = window.innerHeight - correction;
	

list += "<form name=QueueForm>";
list += "<table border='0' cellpadding='2' cellspacing='0' width='100%'>";
list += "<tr class=bg1><td><font><b>List of Queues for " + qmgr + "</b></font></td><td colspan='2' align='right'><b><a href='#' onClick=parent.parent.M_openCreateQueueDialog('"+type +"')><font> Create Queue </font></a></b></td></tr>";
if(type == TYPEMQ)
	list += "<tr class='bg2'><td width='77%'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<font class='dark'><b><a href='#' class ='list' onClick=parent.parent.setCursor(124)> Name </b></font></td><td align='left' width='12%'><font class='dark'><b><a href='#' class ='list' onClick=parent.parent.setCursor(125)> Type</b></font>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td align='left'><font class='dark'><b><a href='#' class ='list' onClick=parent.parent.setCursor(126)> Depth</b></font>&nbsp;</td></tr></table>";
else
	list += "<tr class='bg2'><td colspan='3'>&nbsp;&nbsp;&nbsp;<font class='dark'><b> Name </b></font></td></tr></table>";

list += "<DIV id='listDiv' STYLE='height:"+heightScreen+";overflow:auto;width:100%;table-layout:fixed' class='scroll'>";
list += "<table border='0' style='table-layout:fixed' cellpadding='5' cellspacing='0' width='100%'>";

var countMQ=0;
var qnameJMS;


var x=xmlMQAttrib.getElementsByTagName("Queue");
//M_alert("There are no queues matching the filter criteria for the queue manager " +x.length+ ".");	
for (var i=0;i<x.length;i++) 
{
	var qname= x[i].firstChild.text;
	var q_type=x[i].firstChild.nextSibling.text;
	var q_depth=null;
	if(x[i].lastChild.nodeName=="CURDEPTH")
	{
		var q_depth=x[i].lastChild.text;
	}
	//M_alert("There are no queues matching the filter criteria for the queue manager " +qname1+ "."+q_type1+ "."+q_depth1+ ".");		
	
	 // do something with each <book> element

	if((i+1)%2 == 0)
		list += "<tr class = 'bg2' width='92%'>";
	else
		list += "<tr>";
	var tempQname = rtrim(qname);
	if(type == TYPEMQ)
	{     
		list += "<td width='4.7%'><img id ='Delete"+i+"' width='17' height='17' src ='images/msg_menu.gif' onMouseOut=hidePopupMenu('listT') onmousedown=parent.parent.frame1.hidePopupMenu('');parent.hidePopupMenu('');onMouseDownList(event,'"+tempQname+"','qmgr_name','Delete"+i+"'";
		if(q_type != null)
			list += ",'"+q_type+"'";
		list += ") /></td><td width='74%' align='left'>&nbsp;<font class=ListHeader><b>";
	}
	else
	{
		tempQname = checkSpecialChars(tempQname);
		qnameJMS = checkBackSlash(tempQname);
		list += "<td width='4.7%'><img id ='Delete"+i+"' width='17' height='17' src ='images/msg_menu.gif' onMouseOut=hidePopupMenu('listT2') onmousedown=parent.parent.frame1.hidePopupMenu('');parent.hidePopupMenu('');onMouseDownListJMS(event,"+i+",'qmgr_name','Delete"+i+"') /></td>";
		list += "<td width='74%' align='left'><font class=ListHeader><b>";
	}

	if(type == TYPEMQ)
	{
		if(q_type != null)
			list += "<a href='#' class ='list' onClick=parent.parent.showOpenQDialog('qmgr_name','"+tempQname+"','"+q_type+"') >";
		else
			list += "<a href='#' class ='list' onClick=parent.parent.showOpenQDialog('qmgr_name','"+tempQname+"') >";
		list +=  tempQname + "</a></b></font></td>";
		if(q_type != null)
			list += "<td width='14%' align='left'><font class=MessageAttrib><b>"+ q_type +"</b></font></td>";
		else
			list += "<td width='14%'><font class=MessageAttrib><b></b></font></td>";
			
		if(q_depth != null)
			list += "<td align='left'><div id='td_"+tempQname+"'><font class=MessageAttrib><b>"+ q_depth +"</b></font></td></div></tr>";
		else
			list += "<td><div id='td_"+tempQname+"'><font class=MessageAttrib><b></b></font></div></td></tr>";
	}
	else
	{
		list += "<a href='#' class ='list' onClick=parent.parent.showOpenQDialog('qmgr_name',"+t+") >";
		list += tempQname + "</a></b></font></td>";
		list += "<td></td></tr>";
	}

}

if(x.length==0)
{
	M_alert("There are no queues matching the filter criteria for the queue manager " +qmgr+ ".");
}

list += "</table></DIV></td></tr></table></form>";

//M_alert("There are no queues matching the filter criteria for the queue manager " +qmgr+ ".");
return list;
}


function changeDivHeight()
{

	if(window.parent.frame2.frame3.document.getElementById('listDiv') != null)
		if(browser == "NS")
			window.parent.frame2.frame3.document.getElementById('listDiv').style.height = window.parent.innerHeight - correction;
		else
			window.parent.frame2.frame3.document.getElementById('listDiv').style.height = window.parent.document.body.clientHeight - correction;
		
}



function showQAttributes(qname)
{
	param2 = qname;
	setCursor(10);
}


function showQueueAttributes(qname)
{
	var q_attrib = M_DisplayQueue([qname]);
	if(q_attrib != null  && getTag(RETURNCODE, q_attrib) == "Success")
		ShowWindow('kxyDisQu','','545px','550px',[browser,qname,q_attrib]);
	else
	if(q_attrib != null)
		M_alert(getTag(EXPL,q_attrib,browser),getTag(EXCEPTION,q_attrib,browser),getTag(CCODE,q_attrib,browser),getTag(RCODE,q_attrib,browser));

}



/**********************************************************************************************
The function showOpenQDialog opens the modal dialog window for Opening a Queue. It takes the 
following argument:
qmgr		: is the name of the Queue Manager for whose Queue the open queue dialog window 
		is getting opened.
QName		: is the name of the Queue for which the open queue dialog window is getting 
		opened.
		IF08: add readOnlyUser ?
***********************************************************************************************/

function showOpenQDialog(qmgr,QName,q_type)
{
	param2 = qmgr;
	param3 = QName;
	param4 = q_type;
	setCursor(13);
}

function openQDialog(qmgr,QName,q_type)
{
var params = new Array();
params[0] = qmgr;
params[1] = QName;
var count_depth;
var sync;
var Context;
var Filter = new Array();
var ColFilter = new Array();
var HFilter = new Array();
var HColFilter = new Array();
var LogOrder;
var SgmMsg;
var get;
var IgnoreMDR;
var DisplayHeader;
var rowFilter = new Array();
var rowFilterH=new Array();
var colFilterH=new Array();
var colFilter = new Array();
var qIndex;
var valid = 1;
var ccode = "";
var localProfile;
var fSize="";
var fCount="";
//cjj, the editMaxCount variable controls the maximum size of a message that can be edited, 
//if an exception occurs when the size of the a message being edited is large
var editMaxCount="";
var limitEditMsgExBytes=5242880;
//cjj end
//IF08 begin
var queueReadOnlyUser = false ;
var clearQueueOnlyUser = false ;
//IF08 end


if(QType != TYPEMQ)
{
	var t = QName;
	if(browser == "NS"){
		var d = t +1;
		QName = getTag("//QueueList/Queue["+d+"]",xml_queue);
	}
	else
		QName  = getTag("//QueueList/Queue["+t+"]",xml_queue);
		
params[1] = QName;
QName = checkSpecialChars(QName);
QName = checkBackSlash(QName);
}

if(QType == TYPEMQ)
{
	localProfile = getXMLTag("//"+ QType +"//Backend[Name='"+ActiveQmgr+"']/Queues/Queue[Name=\""+QName+"\"]",userProfile);
	//cjj
	var tmp = getTag("//Body//LimitEditMsgExBytes",userProfile);
    if (tmp != null && tmp != "")
    {
        limitEditMsgExBytes = tmp;
    }
    //cjj end
    //IF08
    var tmpQueueReadOnlyUser = getTag("//Body//QueueReadOnlyUser",userProfile);
    if (tmpQueueReadOnlyUser != null && tmpQueueReadOnlyUser == "true")
    {
    	queueReadOnlyUser = true;
    }
    
    var tmpClearQueueOnlyUser = getTag("//Body//ClearQueueOnlyUser",userProfile);
    if (tmpClearQueueOnlyUser != null && tmpClearQueueOnlyUser == "true")
    {
    	clearQueueOnlyUser = true;
    }
   
}
else
{	var countQ = count("//"+ QType +"//Backend[Name='"+ActiveQmgr+"']/Queues/Queue",userProfile);
	for(var i = 0; i < countQ;i++)
	{
		if(browser == "NS")
			var d = i+1;
		else
			var d = i;
		var node = getXMLTag("//"+ QType +"//Backend[Name='"+ActiveQmgr+"']/Queues/Queue["+d+"]/Name",userProfile);
		if(browser == "NS")
			node = node.iterateNext();
			if(node.firstChild.nodeValue == QName)
			{
				localProfile = getXMLTag("//"+ QType +"//Backend[Name='"+ActiveQmgr+"']/Queues/Queue["+d+"]",userProfile);
				qIndex = d;
				break;
			}
	}
}

if(localProfile == null)
{
    //cjj, if the value in the user profile.xml file is empty, so we get the default value from the config.xml file
    editMaxCount = editMsgExBytes;
    //cjj end
	count_depth = 20;
	sync = 'null';
	Context = 'null';
	Filter = 'null';
	ColFilter = 'null';
	LogOrder = false;
	get = 'null';
	SgmMsg = false;
	IgnoreMDR = false;
	DisplayHeader = false;
}
else
{
	localProfile = localProfile.cloneNode("true");
	var path = "/";
	count_depth = getTag(path+'/Depth',localProfile);

	if(count_depth == "") count_depth = 20;
	sync = getTag(path+'/Sync',localProfile);
	Context = getTag(path+'/Context',localProfile);

	if (browser=="NS")
		n=1;
	else
		n=0;
	var countF = count(path+'/RowFilter/Filter',localProfile);
	for (i=0;i<countF;i++){		
		Filter[i]=getTag(path+'/RowFilter/Filter['+n+']',localProfile);
		n++;
	}

	if (browser=="NS")
		n=1;
	else
		n=0;
	countF = count(path+'/ColumnFilter/Filter',localProfile);
	for (i=0;i<countF;i++){
		ColFilter[i]=getTag(path+'/ColumnFilter/Filter['+n+']',localProfile);n++;}

	if (browser=="NS")
		n=1;
	else
		n=0;
	
	countF = count(path+'/RowHeaderFilter/Filter',localProfile);
	for (i=0;i<countF;i++){
		HFilter[i]=getTag(path+'/RowHeaderFilter/Filter['+n+']',localProfile);n++;}
	if (browser=="NS")
		n=1;
	else
		n=0;
	countF = count(path+'/ColumnHeaderFilter/Filter',localProfile);
	for (i=0;i<countF;i++){
		HColFilter[i]=getTag(path+'/ColumnHeaderFilter/Filter['+n+']',localProfile);n++;
	}

	LogOrder = getTag(path+'/LogOrder',localProfile);
	get = getTag(path+'/get',localProfile);
	SgmMsg = getTag(path+'/SgmMsg',localProfile);
	IgnoreMDR = getTag(path+'/IgnoreMDR',localProfile);
	DisplayHeader = getTag(path+'/DisplayHeader',localProfile);
	var temp1 = getTag(path+'/FieldSize',localProfile);
	if(temp1 != null)
		fSize = temp1;
	temp1 = getTag(path+'/FieldCount',localProfile);
	if(temp1 != null)
		fCount = temp1;
    //cjj, get the value of "EditMsgExBytes" from the user profile.xml file
    temp1 = getTag(path+'/EditMsgExBytes',localProfile);
    if (temp1 != null && temp1 != "")
    {
        editMaxCount = temp1;
    }
    else
    {
    	editMaxCount = editMsgExBytes;
    }
    //cjj end
}
	params[2]=count_depth;
	params[3]=sync;
	params[4]=Context;
	params[5]=Filter;
	params[6]=ColFilter;
	params[7]=LogOrder;
	params[8]=get;
	params[9]=SgmMsg;
	params[10]=IgnoreMDR;
	params[11]=DisplayHeader;

   var xml_result = M_getFilters();

   var count_filter = 0;

   if(xml_result != null && getTag(RETURNCODE,xml_result,browser)=="Success")
   {
	count_filter = count("//Filter",xml_result);
	if(count_filter != 0)
	{
			var nodeFilter = getXMLTag("//Body/Filter",xml_result);
			if(browser == "NS")
				nodeFilter = nodeFilter.iterateNext();
			nodeFilter = nodeFilter.childNodes;
			count_filter = nodeFilter.length;
		
	var n;
	if (browser=="NS")
		n=1;
	else
		n=0;
	for(i=0; i<count_filter;i++)
	{
	   if(nodeFilter[i].nodeName != "#text")
	   {
		if(getTag("//Body/Filter/*["+n+"]/@Type",xml_result)== "row")
		{
			if (getTag("//Body/Filter/*["+n+"]/@Selector",xml_result)== "data")
			{
				rowFilter[rowFilter.length] = nodeFilter[i].nodeName;
			}else{
				rowFilterH[rowFilterH.length] = nodeFilter[i].nodeName;
			}
		}
		else{
			if (getTag("//Body/Filter/*["+n+"]/@Selector",xml_result)== "data")
			{
				colFilter[colFilter.length] = nodeFilter[i].nodeName;
			}else{
				colFilterH[colFilterH.length] = nodeFilter[i].nodeName;

			}
		}
		n++;
	   }
	}
	}
  }
  else
   if(xml_result != null)
   {
  	ccode = getTag(CCODE,xml_result,browser);
  }
  else
  	ccode = "null";

  if (ccode != KXY_ERR_SECURITY && ccode != KXY_ERR_SESSION_CLOSED && ccode != KXY_ERR_IDLE && ccode != "null")
  {
	params[12]=rowFilter;
	params[13]=colFilter;
	params[14]=browser;
	params[15]=rowFilterH;
	params[16]=colFilterH;
	params[17]=HFilter;
	params[18]=HColFilter;	
	
	params[20]=fSize;
	params[21]=fCount;	
	params[22]=maxMessagesDisplay;	
	params[23]=maxFieldSize;	
    params[24]=maxFieldCount;
    //cjj
    params[25]=editMaxCount;
    params[26]=limitEditMsgExBytes;
    //cjj end
    
    //IF08 begin
    params[27]=queueReadOnlyUser;
    params[28]=clearQueueOnlyUser;
    //IF08 end
	
	if(q_type != null)
		params[19]=q_type;
	else
		params[19]="";

	M_showOpenQueueDialog(params);
 }
}



/**********************************************************************************************
The function showDeleteQDialog opens a modal dialog window to prompt the user if he is sure to 
delete the Queue. It takes the following argument:
QName		: is the name of the Queue for which the detlete operation is to be performed.
***********************************************************************************************/
function showDeleteQDialog(QName)
{
	if(QType != TYPEMQ)
	{
		var t = QName;
		if(browser == "NS"){
			var d = t+1;
			QName = getTag("//QueueList/Queue["+d+"]",xml_queue);
		}
		else
			QName  = getTag("//QueueList/Queue["+t+"]",xml_queue);
	}
	ShowWindow('kxydelW','','540px','200px',[QName,browser]);
}


/**********************************************************************************************
The function showClearQDialog opens a modal dialog window to prompt the user if he is sure to 
clear messages from the Queue. It takes the following argument:
QName		: is the name of the Queue for which the detlete operation is to be performed.
***********************************************************************************************/
function showClearQDialog(QName){
	ShowWindow('kxydelMW','','530px','190px',[QName,browser,6]);
}

/**********************************************************************************************
The function getQueueArray stores the names of the Queues for the Queue Manager in an array. 
It takes the following argument:
XMLObj		: is the XML DOM Object for the XML that carries the names of the Queues.
qmgr		: carries the name of the Queue Managers for which the list of queues is 
		getting displayed.
***********************************************************************************************/
function getQueueArray(XMLObj,qmgr){

var xmlQ = new Array();
var countMQ=0;

countMQ = count("//QueueList/Queue",XMLObj);

if(countMQ == 0){
	//M_alert("There are no queues for the queue manager " +qmgr+ ".");
	xmlQ[0] = "";
}
else{
	for(e = 0; e < countMQ; e++){
		if(browser == "NS"){
			var d = e+1;
			xmlQ[e] = getTag("//QueueList/Queue["+d+"]",XMLObj);
		}
		else
			xmlQ[e] = getTag("//QueueList/Queue["+e+"]",XMLObj);
	}	
}
	return xmlQ;
}



/**********************************************************************************************
The function validateCount validates tghe value entered for "Max. Message per display" in open 
Queue window for both MQSeries and JMS.
***********************************************************************************************/
function validateCount(val)
{  
	if(val == "")
	{
		M_alert(err_115);
	}
	else
	if(val < 0){
		M_alert(err_116);

	}else
	if(!checkWholeNumber(val)){
		M_alert(err_117);
	}else
	if(isNaN(val) || val.indexOf('E') != -1 || val.indexOf('e') != -1){
		M_alert(err_118);
	}else
	if(val == 0){
		M_alert(err_119);
	}
	else
	if(val > maxMessagesDisplay){
		M_alert(err_120 + maxMessagesDisplay + ".");
	}
	else
		window_onclose();
}


function validateFldSzCnt(val,flag)
{  
	if(val != "" && (val < 1 || (flag == 1 && val > maxFieldSize) || (flag == 2 && val > maxFieldCount) || !checkWholeNumber(val) || isNaN(val) || val.indexOf('E') != -1 || val.indexOf('e') != -1))
	{
		if(flag == 1)
			M_alert(err_123 + maxFieldSize + " for 'Field Size'.");
		else
			M_alert(err_123 + maxFieldCount + " for 'Field Count'.");
		return false;
	}
	else
		return true;

}

/**********************************************************************************************
The function validateEditMsgExBytes validates the value entered for "validateEditMsgExBytes" in open 
Queue window for both MQSeries and JMS.  cjj
***********************************************************************************************/
function validateEditMsgExBytes(val)
{
    if(val == "")
    {
        M_alert(err_124);
        document.OpenQueueForm.editMsgExBytes.focus();
        return false;
    }
    if(val <= 0)
    {
        M_alert(err_127);
        document.OpenQueueForm.editMsgExBytes.focus();
        return false;
    }
    if(isNaN(val) || val.indexOf('E') != -1 || val.indexOf('e') != -1 || !checkWholeNumber(val))
    {
        M_alert(err_125);
        document.OpenQueueForm.editMsgExBytes.focus();
        return false;
    }
    if(parseInt(val) > parseInt(limitEditMsgExBytes))
    {
        M_alert(err_128 + limitEditMsgExBytes);
        document.OpenQueueForm.editMsgExBytes.focus();
        return false;
    }
    else
    {
        return true;
    }
}
//cjj end

function showFilterByType(type)
{
	if(type == TYPEMQ)
	{
		closeFilter(TYPEJMS);
		openFilter(type);	
	}
	else
	{
		closeFilter(TYPEMQ);
		openFilter(type);		
	}
}


function closeFilter(type)
{
	var tmp = frame2.frame3.document;
	var tmp1 = 'typesMQ';
	var tmp2 = 'imageMQ';
	if(type != TYPEMQ)
	{
		tmp1 = 'typesJMS';
		tmp2 = 'imageJMS';
	}
	tmp.getElementById(tmp1).style.display="none";
	tmp.getElementById(tmp2).src='images/triclose.gif';
}



function openFilter(type)
{
	var tmp = frame2.frame3.document;
	var tmp1 = 'typesMQ';
	var tmp2 = 'imageMQ';
	if(type != TYPEMQ)
	{
		tmp1 = 'typesJMS';
		tmp2 = 'imageJMS';
	}
    else
    {
        var frm = tmp.getElementById('QTypeForm')
        frm.qsel[currentTypeFilter].checked = true;
    }
	tmp.getElementById(tmp1).style.display="block";
	tmp.getElementById(tmp2).src='images/triopen.gif';
}