/*
#$Id: kxyServr.js,v 1.1.2.5 2009/08/24 02:41:40 cjj Exp $#
######################################################################

             IBM Confidential
             
             OCO Source Materials
             
             (C) Copyright IBM Corp. 2005-2007
             
             The source code for this program is not
             published or otherwise divested of its
             trade secrets, irrespective of what has
             been deposited with the U.S Government
             Copyright Office.

######################################################################
######################################################################
# Copyright 1999-2003, Candle Corporation, a California corporation.  
# All rights reserved. International copyright secured.
#
# This material is proprietary to Candle Corporation and is not to be
# reproduced, used, or disclosed except in accordance with program
# licenses or upon written authorization of Candle Corporation.
#
#######################################################################*/
var handle=null;
var originalHandle=null; // for unix
var connid=-2; // -2=disconnected
var backconnid=-2;  // no queue opened
var globalProfile;
var userProfile;
var url;
var queueAdmin = "Yes";

var newCredentials = "Yes";
var maxMessagesDisplay = 200;
var maxFieldSize = 100;
var maxFieldCount = 10;
var disableDeleteFile = false;
var enableXMLUnload = false;
var enableQueueNameFilter = false;
var queueNameList;
var queueNameMask;
var queueNameRelation;
/*cjj, This editMsgExBytes controls the maximum size of a message that can be edited, if an exception 
occurs (no matter whether the "Ignore Message Formatting" option is selected)
when the size of the a message being edited is large.*/
var editMsgExBytes;
//cjj end

function S_login(userid,password)
// Logs to the server
{
   url=get_url();  // *************  change localhots:8080 for this url ***********************
   var xml_login= XML_getXMLLogin(userid,password);	  // gets the xml to login
   var xmlResponse=sendServer(xml_login,url+"/RPC2");	   // sends the xml to the server
   if (xmlResponse != null && getTag(RETURNCODE,xmlResponse)=="Success")
	{
 	   if (getTag("//Body/ClientConnectionCredentials",xmlResponse) == "No")
 		newCredentials = "No";

	   if (getTag("//Body/EnableXMLUnload",xmlResponse) != null)
 		enableXMLUnload = (getTag("//Body/EnableXMLUnload",xmlResponse) == "Yes");

		if (getTag("//Body/DisableDeleteLoadFile",xmlResponse) != null)
 		disableDeleteFile = (getTag("//Body/DisableDeleteLoadFile",xmlResponse) == "Yes")
		
	   if (getTag("//Body/MessageCount",xmlResponse) != null)
 		maxMessagesDisplay = parseInt(getTag("//Body/MessageCount",xmlResponse));

	   if (getTag("//Body/FieldSize",xmlResponse) != null)
 		maxFieldSize = parseInt(getTag("//Body/FieldSize",xmlResponse));

	   if (getTag("//Body/FieldCount",xmlResponse) != null)
 		maxFieldCount = parseInt(getTag("//Body/FieldCount",xmlResponse));
       
	   enableQueueNameFilter = false;
	   if (getTag("//Body/EnableQueueNameFilter",xmlResponse) != null)
 		enableQueueNameFilter = (getTag("//Body/EnableQueueNameFilter",xmlResponse) == "Yes");
       //cjj, get the value editMsgExBytes from the user profile.xml file
	   if (getTag("//Body/EditMsgExBytes",xmlResponse) != null)
 		editMsgExBytes = (getTag("//Body/EditMsgExBytes",xmlResponse));
	   //cjj end
	   if (handle!=null)
		originalHandle=handle;
	   handle=getTag(HANDLE,xmlResponse,browser);		// sets the handle 
	   globalProfile=getGlobalProfile(handle);					// sets the global profile
	   userProfile=getUserProfile(handle);  					// sets the user's profile

	   if (enableXMLUnload && getTag("//EnableXMLUnload",userProfile) != null)
 			enableXMLUnload = (getTag("//EnableXMLUnload",userProfile) == "Yes");
	   if(getTag("//EnableXMLUnload",userProfile) == null)
	   	   enableXMLUnload =false;
		   
	   if(getTag("//QueueNameMask",userProfile) != null)
	   	   queueNameMask =(getTag("//QueueNameMask",userProfile));
		   
	   if(getTag("//QueueNameList",userProfile) != null)
	   	   queueNameList =(getTag("//QueueNameList",userProfile));
		   
	   if(getTag("//QueueNameList",userProfile) != null)
	   	   queueNameRelation =(getTag("//QueueNameRelation",userProfile));
   }
   return xmlResponse;								// returns the xml
}


function S_logout()
{
   S_handleTimeOut();

   if (backconnid!=-2)  // there is someone connected
   {
	xmlResult=S_disconnectMgr();
	if (getTag(RETURNCODE,xmlResult,browser)!="Success")
		return xmlResult;
    }
    var xml=XML_logout(handle,connid);
    xmlResult=sendServer(xml,url+"/RPC2");
    return xmlResult;
}

function S_disconnectMgr()
{
 var xml_close=XML_getXMLClose(handle,backconnid);
 var xmlResultClose=sendServer(xml_close,url+"/RPC2");
 if (getTag(RETURNCODE,xmlResultClose,browser)=="Success")
 {
	connid=-2;
	return xmlResultClose;
 }
 else
 {
	//M_alert(getTag(EXCEPTION,xmlResultClose,browser));
	return xmlResultClose;
 }
}

//********************************************************************************
//**********************				**************************
//**********************	LIST FUNCTIONS		**************************
//**********************				**************************
//********************************************************************************


function S_createConnection(name,type,clname,clPro)
// sends a request to create connection and returns the response from the server
{
	var xml_cc;
	var xml_close;
	var xmlResultClose;
	var xmlResult;
	if (connid!=-2)			// if there is other connection open -> close it
	{
		xml_close=XML_getXMLClose(handle,connid);
		xmlResultClose=sendServer(xml_close,url+"/RPC2");
		
		if (!unix && getTag(RETURNCODE,xmlResultClose,browser)=="Success")
		{

			connid=-2;
			if (originalHandle!=null)
			{
				if(unix==false)
				{
					xmlResult=S_logout();	// I close the session for that connection
					if (getTag(RETURNCODE,xmlResult,browser)!="Success")
					{	
						M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
						return 0;
					}else
						setHandle(originalHandle);
				}else
					setHandle(originalHandle);
					originalHandle = null;
			}
		}
		else
		if(!unix)
		{
			M_alert(getTag(EXPL,xmlResultClose,browser),getTag(EXCEPTION,xmlResultClose,browser),getTag(CCODE,xmlResultClose,browser),getTag(RCODE,xmlResultClose,browser));
			return null;
		}
		else
		{
			connid=-2;
			setHandle(originalHandle);
			originalHandle = null;
		}
		
	}


	if (unix==true)
	{
		createConn=1;
		xmlResult=S_login(uid,pass);
		if (getTag(RETURNCODE,xmlResult,browser)!="Success")
		{
			return xmlResult;
		}
		
	}	
	if (type==TYPEMQ)	
		xml_cc=XML_getXMLCreateConnection(name,type,handle,clname,clPro);
		
	else
	{
		xml_cc=XML_getXMLCreateConnection(name,type,handle);
	}	
	createConn=1;	
	xmlResult=sendServer(xml_cc,url+"/RPC2");
	createConn=0;
	if (getTag(RETURNCODE,xmlResult)=="Success")
	{
		connid=getTag(XPATHCONNID,xmlResult,browser);
		if (type==TYPEMQ)
			queueAdmin=getTag(XPATHQADMIN,xmlResult,browser);
		else
			queueAdmin = "Yes";
	}
	
	return xmlResult;
}

function S_listQueues(type,qname)
// sends a request to list queues for type and returns server's response
{
	var xml_lc;
	xml_lc=XML_getXMLListQueues(handle,connid,type,qname);
	return sendServer(xml_lc,url+"/RPC2");
}



function S_RefreshQueues(name,type,sortBy)
// sends a request to get attributes for queue with the name and returns server's response
{
	var xml=XML_RefreshQueues(handle,connid,name,type,sortBy);
	return sendServer(xml,url+"/RPC2");
}



function S_DisplayQueue(name,attrib,type,count)
// sends a request to get attributes for queue with the name and returns server's response
{
	var xml=XML_DisplayQueue(handle,connid,name,attrib,type,count);
	return sendServer(xml,url+"/RPC2");
}



function S_ClearQueue(name)
// sends a request to remove messages from queue with the name and returns server's response
{
	var xml=XML_ClearQueue(handle,connid,name);
	return sendServer(xml,url+"/RPC2");
}



function S_createQueue(param,type)
// sends a request to create a queue and returns server's response
{
  	var xml_c;
	if (type==TYPEMQ)
		xml_c=XML_getXMLCreateQueue(TYPEMQ,param,handle,connid);
	else
		xml_c=XML_getXMLCreateQueue(TYPEJMS,param,handle,connid); 
	return sendServer(xml_c,url+"/RPC2");	
}

function S_delete(name,purge)
// sends a request to delete a queue and returns server's response
{

var xml_d;
	xml_d=XML_getXMLDelete(handle,connid,name,purge);
	return sendServer(xml_d,url+"/RPC2");	
}

//********************************************************************************
//*********************					**************************
//********************* 	TREE FUNCTIONS		**************************
//*********************					**************************
//********************************************************************************


function S_listResources(type)
// gets the list of qmgrs
{
  S_handleTimeOut();
  var xml_listResources=XML_getXMLListR(type,handle);			// gets the xml to list resources
  return sendServer(xml_listResources,url+"/RPC2");  // sends it to the server
}

function S_getClientConnections()
// gets the client connections from the global profile
{
    return globalProfile;
   //return getXMLTag(XPATHCLIENTCONNECTION,globalProfile,browser);
}

function S_addNewClientConnection(params)
// adds a new connection to the global profile
{
   var xmlNewcc=XML_UpdateGPCl(handle,params); // returns a string with the xml
   return sendServer(xmlNewcc,url+"/RPC2");
}

function S_addNewJMS(params)
// adds a new jms to the global profile
{
   var xmlNewcc=XML_UpdateGPJMS(handle,params); // returns a string with the xml
   return sendServer(xmlNewcc,url+"/RPC2");
}

function S_removeJMS(params)
// removes a jms from the global profile
{
   var xmlr=XML_removeJMS(handle,params);  // returns a string with the xml
   return sendServer(xmlr,url+"/RPC2");
}

function S_updateJMS(params)
// updates a JMS connection from the global profile
{
   var xmlr= XML_UpdateGPJMS(handle,params);  // returns a string with the xml
   return sendServer(xmlr,url+"/RPC2");
}


function S_removeClient(params)
// removes a client connection from the global profile
{
   var xmlr=XML_removeClient(handle,params);  // returns a string with the xml
   return sendServer(xmlr,url+"/RPC2");
}

function S_updateClient(params)
// updates a client connection from the global profile
{
   var xmlr= XML_UpdateGPCl(handle,params);  // returns a string with the xml
   return sendServer(xmlr,url+"/RPC2");
}


function S_updateJMS(params)
// updates a client connection from the global profile
{
   var xmlr= XML_UpdateGPJMS(handle,params);  // returns a string with the xml
   return sendServer(xmlr,url+"/RPC2");
}


//********************************************************************************
//**********************				**************************
//**********************	Message Window		**************************
//**********************				**************************
//********************************************************************************


function S_openQueue(options)
// opens a queue with the options specified
{
	var xmlopen=XML_openQueue(handle,connid,options);
	return sendServer(xmlopen,url+"/RPC2");
}

function S_peek(params,Tag)
// gets the messages from a queue
{
	var xmlopen=XML_peek(handle,connid,params,Tag);
	return sendServer(xmlopen,url+"/RPC2");
}

function S_listAvailFmt(sysFmt)
{
  S_handleTimeOut();
  var xml=XML_listAvailFmt(handle,connid,sysFmt);
  return sendServer(xml,url+"/RPC2");
}

function S_getMetaData(fmt)
{
  var xml=XML_getMetaData(handle,connid,fmt);
  var result = sendServer(xml,url+"/RPC2");
  return result;
}

function S_getHeaderMetaData(fmt)
{
  var xml=XML_getHeaderMetaData(handle,connid,fmt);
  var result = sendServer(xml,url+"/RPC2");
  return result;
}


function S_ListMBCS()
{
  var xml=XML_ListMBCS(handle);
  return sendServer(xml,url+"/RPC2"); 
}

function S_createMess(params,col,val)
// creates a message
{
	var xml=XML_createMess(handle,connid,params,col,val);
	return sendServer(xml,url+"/RPC2");
}

function S_refresh()
// refreshes the table of messages
{
	var xml=XML_refresh(handle,connid);
	return sendServer(xml,url+"/RPC2");	
}

function S_Buffer()
// refreshes the table of messages
{
	var xml=XML_Buffer(handle,connid);
	return sendServer(xml,url+"/RPC2");	
}


function S_closeQ()
// closes the opened queue
{
   var xml=XML_closeQ(handle,connid);
   return sendServer(xml,url+"/RPC2");
}

function S_deleteMsg(ids)
// deletes all the messages with ids in ids
{
  var xml=XML_deleteMsg(handle,connid,ids);
  return sendServer(xml,url+"/RPC2");
}

function S_copyMsg(ids)
// copies all the selected messsages to the clipboard
{
  var xml=XML_copyMsg(handle,connid,ids);
  return sendServer(xml,url+"/RPC2");  
}

function S_cutMsg(ids)
// cuts all the selected messages to the clipboard
{
  var xml=XML_cutMsg(handle,connid,ids);
  return sendServer(xml,url+"/RPC2");  
}

function S_paste(mode)
// paste the messages of the clipboard in the open queue
{
 var xml=XML_paste(handle,connid,mode);
 return sendServer(xml,url+"/RPC2");  
}

function S_forward(qname,qmgr,ids,strip,retry)
// forwards selected messages to qname from qmgr
{
  var xml=XML_forward(handle,connid,qname,qmgr,ids,strip,retry);
  return sendServer(xml,url+"/RPC2");  
  
}

function S_availFiles(common, fileFilter)
{
  var xml=XML_availFiles(handle,backconnid,common,fileFilter);
  return sendServer(xml,url+"/RPC2");  
}

function S_load(file)
{
  var xml=XML_load(handle,connid,file);
  return sendServer(xml,url+"/RPC2");  
}

function S_unload(file,append,ids,deleteMessages,toXML,separate,header,split)
{
  var xml=XML_unload(handle,connid,file,append,ids,deleteMessages,toXML,separate,header,split);
  return sendServer(xml,url+"/RPC2");  
}

function S_setHexValue(field,value,id)
{
	
  var xml=XML_setHexValue(handle,backconnid,id,field,value);
  var result = sendServer(xml,url+"/RPC2");
  if (result != null && getTag(RETURNCODE,result,browser)=="Success")
  	M_HoldTimer();
  return result;
}

function S_getHex(value,CCSID)
{
	
  var xml=XML_getHex(handle,backconnid,value,CCSID);
  var result = sendServer(xml,url+"/RPC2");
  if (result != null && getTag(RETURNCODE,result,browser)=="Success")
  	M_HoldTimer();
  return result; 
}

function S_getText(value,CCSID)
{
	
  var xml=XML_getText(handle,backconnid,value,CCSID);
  var result = sendServer(xml,url+"/RPC2");
  if (result != null && getTag(RETURNCODE,result,browser)=="Success")
  	M_HoldTimer();
  return result;
}


function S_getHexValue(field,id)
{
	
  var xml=XML_getHexValue(handle,backconnid,field,id);
  var result = sendServer(xml,url+"/RPC2");
  if (result != null && getTag(RETURNCODE,result,browser)=="Success")
  	M_HoldTimer();
  return result; 
}

//zhou parse unknownformat message
function S_ParseMsgAgain(field,id)
{
	
  var xml=XML_ParseMsgAgain(handle,backconnid,field,id);
  var result = sendServer(xml,url+"/RPC2");
  //alert("S_ParseMsgAgain  "+result.text);
  if (result != null && getTag(RETURNCODE,result,browser)=="Success")
  	M_HoldTimer();
  	
  return result; 
}

//zhou parse unknowningoreformat message
function S_ParseIngoreMsgAgain(field,id)
{
	
  var xml=XML_ParseIngoreMsgAgain(handle,backconnid,field,id);
  var result = sendServer(xml,url+"/RPC2");
  //alert("S_ParseIngoreMsgAgain  "+result.text);
  if (result != null && getTag(RETURNCODE,result,browser)=="Success")
  	M_HoldTimer();
  	
  return result; 
}

function S_update(msg,kxyType,col,val,colName)
{
var xml=null;

var xml=XML_update(handle,connid,msg,kxyType,col,val,colName);
  if (xml!=null)
	  return sendServer(xml,url+"/RPC2");  
  else
	return null;
}

function S_commit()
{
 var xml=XML_commit(handle,connid);
  return sendServer(xml,url+"/RPC2");  
}

function S_rollback()
{
 var xml=XML_rollback(handle,connid);
  return sendServer(xml,url+"/RPC2");  
}

function S_find(column,value,mode,kxyT,check,fmt,index,all)
{
 var xml=XML_find(handle,connid,column,value,mode,kxyT,check,fmt,index,all);
  return sendServer(xml,url+"/RPC2");  
}

function S_replace(msgconnid,column,old_value,new_value,offset,fmt,kxyT,index)
{
  var xml=XML_replace(handle,connid,msgconnid,column,old_value,new_value,offset,fmt,kxyT,index);
  return sendServer(xml,url+"/RPC2");
}

function S_apply(doapply,col,kxyT,index,fmt)
{
  var xml=XML_apply(handle,connid,doapply,col,kxyT,index,fmt);
  return sendServer(xml,url+"/RPC2");
}

function S_saveFilter(name,type,format,expression,selector)
{
 var xml=XML_saveFilter(handle,name,type,format,expression,selector);
  return sendServer(xml,url+"/RPC2");  
}

function S_delFilter(name)
{
 var xml=XML_delFilter(handle,name);
  return sendServer(xml,url+"/RPC2");  
}

function S_updateFilter(name,type,format,expression,selector)
{
 var xml=XML_updateFilter(handle,name,type,format,expression,selector);
  return sendServer(xml,url+"/RPC2");  
}

function S_getFilters(name,type,format,expression,selector,sysFmt)
{
 var xml=XML_getFilters(handle,name,type,format,expression,selector,sysFmt);
  return sendServer(xml,url+"/RPC2");  
}



function S_addVariant(name,filter,message_format,real_format)
{
 var xml=XML_addVariant(handle,name,filter,message_format,real_format);
  return sendServer(xml,url+"/RPC2");  
}

function S_deleteVariant(name)
{
 var xml=XML_deleteVariant(handle,name);
  return sendServer(xml,url+"/RPC2");  
}

function S_updateVariant(name,filter,message_format,real_format)
{
 var xml=XML_updateVariant(handle,name,filter,message_format,real_format);
  return sendServer(xml,url+"/RPC2");  
}

function S_getVariants(name,filter,message_format,real_format,owner)
{
 var xml=XML_getVariants(handle,name,filter,message_format,real_format,owner);
  return sendServer(xml,url+"/RPC2");  
}

function S_HoldTimer(cancel)
{
  var xml=XML_HoldTimer(handle,cancel);
  return sendServer(xml,url+"/RPC2");  
}


//********************************************************************************
// Internal functions
//********************************************************************************

//********************
// profile functions
//********************

function getGlobalProfile(handle)
// sends a request to get the global profile and returns the server's response
{
  var xml_globalProfile=XML_getXMLGlobalProfile(handle);
  return sendServer(xml_globalProfile,url+"/RPC2");
}


function updateUserProfile(handle,profile)
// sends a request to set the user profile and returns the server's response
{
  var resturnXML=XML_updateXMLUserProfile(handle,connid,profile);
  return sendServer(resturnXML,url+"/RPC2");
}

function updateUserProfileStr(handle,newQueue)
// sends a request to set the user profile and returns the server's response
{
  var resturnXML=XML_updateXMLUserProfileStr(handle,connid,newQueue);
  return sendServer(resturnXML,url+"/RPC2");
}


function S_addQueueProfile(array_options)
{
  var newQueue;
  newQueue=XML_addQueueProfile(array_options[0],array_options);

  var xmlResult= updateUserProfileStr(handle,newQueue);
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
   {
	  userProfile=getUserProfile(handle);
	  return userProfile;
    }
    else
      if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
}



function S_updateQueueProfile(array_options)
{
  var queueName=array_options[0];
var i,j;

  for (i=1;i<=13;i++){
	XML_updateNodeProfile(queueName,OPENOPTIONS[i-1],'',array_options[i]);}
j=15;
  if ((array_options[14]!='null'))
  {
	flt=0;
        for (p=0;p<array_options[14];p++)
		flt++;
	if (browser=="NS")
		f=1;
	else
		f=0; 
        XML_removeNodes("//"+QType+"//Backend[Name='"+ActiveQmgr+"']/Queues/Queue[Name='"+queueName+"']/RowFilter",userProfile)
        if (array_options[14]!=0)
         for (j=15;j<15+flt;j++)
  	 {
		XML_updateNodeProfile(queueName,OPENOPTIONS[13],"["+f+"]",array_options[j]);		
		f++;
	 }		
  }  
k=j+1;

  if ((array_options[j]!='null'))
  {
	flt=0;
        for (p=0;p<array_options[j];p++)
		flt++;
       if (browser=="NS")
		f=1;
	else
		f=0; 

	XML_removeNodes("//"+QType+"//Backend[Name='"+ActiveQmgr+"']/Queues/Queue[Name='"+queueName+"']/ColumnFilter",userProfile);
        if (array_options[j]!=0)
 	   for (k=j+1;k<=j+flt;k++)
	   { 
		XML_updateNodeProfile(queueName,OPENOPTIONS[14],"["+f+"]",array_options[k]);		
		f++;
	    }		
  }
//update row header filters

j=k+1;  
 if ((array_options[k]!=null))
  {
	flt=0;
        for (p=0;p<array_options[k];p++)
		flt++;
        if (browser=="NS")
		f=1;
	else
		f=0; 
	XML_removeNodes("//"+QType+"//Backend[Name='"+ActiveQmgr+"']/Queues/Queue[Name='"+queueName+"']/RowHeaderFilter",userProfile)
        if (array_options[k]!=0)
 	   for (j=k+1;j<=k+flt;j++)
	   { 
		XML_updateNodeProfile(queueName,OPENOPTIONS[15],"["+f+"]",array_options[j]);		
		f++;
	    }		
  }
  //cjj
  if (array_options[array_options.length-3] != null)
  {
    XML_updateNodeProfile(queueName, "EditMsgExBytes" , "" ,array_options[array_options.length-3]);
  }
  //cjj end
  

// update column header filters
 if ((array_options[j]!=null))
  {
	flt=0;
        for (p=0;p<array_options[j];p++)
		flt++;
  	if (browser=="NS")
		f=1;
	else
		f=0; 
	XML_removeNodes("//"+QType+"//Backend[Name='"+ActiveQmgr+"']/Queues/Queue[Name='"+queueName+"']/ColumnHeaderFilter",userProfile)
        if (array_options[j]!=0)
 	   for (k=j+1;k<=j+flt;k++)
	   { 
		XML_updateNodeProfile(queueName,OPENOPTIONS[16],"["+f+"]",array_options[k]);		
		f++;
	    }		
  }  

  userQueue = getXMLTag("//"+QType+"//Backend[Name='"+ActiveQmgr+"']/Queues/Queue[Name='"+queueName+"']",userProfile,browser);
  if (browser=="NS")
  {
    var nod=userQueue.iterateNext();
    userQueue=nod;
    if (!userQueue){
	userQueue=null;
   }
}
  var xmlResult = updateUserProfile(handle,userQueue);
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
   {
	  userProfile=getUserProfile(handle);
	  return userProfile;
    }
    else
      if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));

}


function getUserProfile(handle)
// sends a request to get the user's profile and returns the server's response
{
  var xml_userProfile=XML_getXMLUserProfile(handle);
  return sendServer(xml_userProfile,url+"/RPC2");

}


function S_colProfile(path)
{
  return getXMLTag(path,userProfile,browser);
}

function S_colFilter(colname,mode,type)
{
  var xml=S_colProfile(type);
  if (mode=='hide')
	XML_addNode(xml,colname);
  else
        XML_removeNode(xml,colname);
}


function getGP()
{ return globalProfile;}

function getUP()
{ return userProfile;}

function getHandle()
{ return handle;}

function getConnid()
{ return connid;}

function setHandle(h)
{ handle=h; }

function setBackConnid(c)
{ backconnid=c; }

function getBackConnid()
{ return backconnid;}

function setConnid(c)
{  connid=c; }


function S_handleTimeOut()
{
	if(timeOut == 2)
	{
		timeOut = 0;
		var xmlResult = S_login();
		if(xmlResult != null && getTag(RETURNCODE, xmlResult) == "Success")
		{
			uid = getTag("//UserId", xmlResult);
			pass = getTag("//Password", xmlResult);
			eval("parent."+FRAME0+".location='kxyHe.htm'");
			M_ListMBCS();
		}
	}
}	
	
function sendServer(xml,urlp)
{
var auxport;

if ((secondConn==1)&&(createConn==1))   // i have an alternative port, i have to go back to the old one
{

	auxport=location.port;
	urlp=urlp.replace(auxport,oldport);
	newport=null;
	createConn=0;
	secondConn=0;
}

if (newport!=null)
{
	oldport=location.port;
	urlp=urlp.replace(oldport,newport);
	url=urlp.substring(0,urlp.length-5);
}	


if (getBrowser() == "NS"){
	x = sendServerNS(xml,urlp);
	return x;}
else{

	x= sendServerIE(xml,urlp);
	if(x != null){
		if (debug_On==true)
		logResp(getXMLTag("//Header",x));
		return x;
	}
	else
	if(unix == false)
	{
		if(window.parent.parent.parent != null){
				window.parent.parent.parent.close();
		}else
		if(window.parent.parent != null){
			window.parent.parent.close();
		}else
		if(window.parent != null){
			window.parent.close();	
		}else{
			window.close();
		}
		return null;
	}
	}
}

function sendServerNS(xml,url)
// sends the request in xml to the server using url, netscape version
{
   var p=new DOMParser();
   var request=new XMLHttpRequest();
   request.open("POST",url,false,null,null);
   request.send(p.parseFromString(xml,"text/xml"));
   
  // while ((request.readyState<4)&&(i<MAXTIME))
  // 	i++;
 //  if ((i<=MAXTIME)&&(request.readyState==4))

  return request.responseXML;
//   else
//	M_alert("Error connecting to server");

}


function sendServerIE(xml,url)
// sends the request in xml to the server using url, ie version
{
	document.body.style.cursor = 'wait';//DCC	
 try {
   var request;
   try{
   	request = new ActiveXObject("Msxml2.XMLHTTP");
   }
   catch (e) {
   	try{
     request = new ActiveXObject("Microsoft.XMLHTTP");
    }
    catch (e) {
    	alert("Server possibly down. Window will now close.");
    	window.opener = null;
    	window.close();
  		document.body.style.cursor = 'auto';//DCC
    	return null;
    }
   }

   request.open("POST",url,false);
   request.send(xml);
	 document.body.style.cursor = 'auto';//DCC
   return request.responseXML;
  }
  catch (e) {
    if (unix==false)
    {
    	alert("Server possibly down. Window will now close.");
    	window.opener = null;
    	window.close();
    	document.body.style.cursor = 'auto';//DCC
    	return null;
    }
    else
    {
    	connid=-2;	
	timeOut = 1;
	
	if(originalHandle != null)
	{
		newport = null;
		M_alert(err_342);
		initializeTimeOut();
	}
	else
	{
		M_alert(err_342);
		window.close();
	}
	document.body.style.cursor = 'auto';//DCC	
	return null;
    }
  }
}

